
; Public Domain

; test install command: install; chstool; chstool uninstall
; test run command: ; .; .

%include "lmacros3.mac"

%include "eld.mac"
%include "eldcall.mac"
%include "elddata.mac"


	cpu 8086

	addsection RELOCATEDDATA, nobits vstart=_ELD_RELOC_VSTART
relocateddata:

	addsection HEADER, start=0

	istruc ELD_HEADERX
at eldhxHeader
		; ELD executable header
	istruc ELD_HEADER
at eldhSignature,	db "ELD1"
			db 0,0,0
			db 26
at eldhCodeOffset,	dd CODEOFFSET
at eldhCodeImageLength,	dw code_size
at eldhCodeAllocLength,	dw 0
at eldhDataOffset,	dd DATAOFFSET
at eldhDataImageLength,	dw data_size
at eldhDataAllocLength,	dw total_data_size - data_size
at eldhCodeEntrypoint,	dw linker - code
at eldhReserved
at eldhExtensionSize,	dw header_extension_end - $$
	iend
at eldhxDescriptionOffset,	dd description
at eldhxHelpOffset,		dd DATAOFFSET + msg.help - datastart
header_extension_end:
	iend

description:		asciz "CHS calculation tool."


	align 16, db 0

	eldstrict on

CODEOFFSET equ $ - $$
	addsection CODE, follows=HEADER vstart=_ELD_CODE_VSTART
%define CODEFIXUP - code + 0
code:
		; ELD instance header
	istruc ELD_INSTANCE
at eldiStartCode
at eldiEndCode
at eldiStartData
at eldiEndData
at eldiIdentifier,	fill 8, 32, db "CHSTOOL"
at eldiListing,		asciz _ELD_LISTING
	iend


command:
	jmp strict short .entry
.chain:
	extcall cmd3_not_ext, required	; must NOT be extcallcall
	times 10 - ($ - command) nop
.entry:
	push si
	cmp al, '-'
	jne @F
	extcallcall skipcomma
@@:
	dec si

reloc	mov dx, msg.chstool
internaldatarelocation
	extcallcall isstring?
	je .ours
	pop si
	dec si
	lodsb
	jmp .chain

.ours:
	pop ax
	extcallcall skipcomma
	dec si
reloc2	mov word [relocateddata], relocateddata
linkdatarelocation lastcmd, -4
linkdatarelocation dmycmd
reloc	mov dx, relocateddata
linkdatarelocation msg.uninstall
	extcallcall isstring?
	je uninstall

	call run
	extcallcall cmd3

uninstall:
	lodsb
	extcallcall chkeol

	call get_es_ext

	push es
	pop ds
	xor bx, bx		; = 0 (no prior, modify ext_command_handler)
reloc	mov di, command		; di -> us
internalcoderelocation
reloc	mov si, word [ss:relocateddata]
linkdatarelocation ext_command_handler
				; si -> first
	test si, si		; none installed ?
	jz .error		; error -->

.loop:
	cmp di, si		; found ?
	je .bx			; yes, use bx -->
	mov bx, si		; bx -> prior handler
	lodsw			; skip entrypoint jmp strict short
	lodsb			; get first byte of chainer
	cmp al, 0E9h		; expecting jmp near ?
	jne .error		; no, error -->
	lodsw			; get rel16 displacement
	add si, ax		; -> next handler
	jmp .loop

.bx:
	test bx, bx		; any prior ?
	jnz .bxnz		; yes -->
	scasw			; skip entrypoint jmp strict short
	cmp byte [di], 0E8h	; is it a call to cmd3_not_ext ?
	jne @F			; no -->
				; yes, reset ext_command_handler to zero
.setbx:
reloc	mov word [ss:relocateddata], bx
linkdatarelocation ext_command_handler
	jmp .done

@@:
	cmp byte [di], 0E9h	; validate
	jne .error		; failure -->
	inc di			; -> rel16 displacement
	mov bx, word [di]	; get displacement
	scasw			; -> after jmp near
	add bx, di		; -> next handler
	jmp .setbx		; set ext_command_handler to next

.bxnz:
	mov si, bx		; -> prior handler with us as downlink
	xchg di, si		; si -> ours, di -> prior
	cmpsw			; skip entrypoint jmp strict short
	movsb			; copy 0E8h/0E9h
	lodsw			; ax = near rel16 displacement
	add ax, si		; add in our base (= absolute offset)
	sub ax, di
	dec ax
	dec ax			; subtract new base (= relative displacement)
	stosw			; store new rel16 displacement
	movsw			; jmp strict short
	movsw			; linkcall target
	movsb			; trailer
.done:
reloc	clropt [code + eldiFlags], eldifResident
internalcoderelocation -3	; mark block as free
reloc	mov dx, msg.uninstall_done
internaldatarelocation
@@:
	push ss
	pop ds
	extcallcall putsz
	extcallcall cmd3	; return

.error:
	mov ax, 0E01h
	extcallcall setrc
reloc	mov dx, msg.uninstall_error
internaldatarelocation
	jmp @B


get_es_ext:
reloc	mov es, word [relocateddata]
linkdatarelocation extdssel
	extcallcall ispm
	jz @F
reloc	mov es, word [relocateddata]
linkdatarelocation extseg
@@:
	retn


run:
	push ss
	pop es

	xor ax, ax
reloc	mov word [heads], ax
internaldatarelocation
reloc	mov word [sectors], ax
internaldatarelocation

.loop:
.heads:
reloc	mov dx, msg.heads
internaldatarelocation
	extcallcall isstring?
	jne .sectors
@@:
	extcallcall skipcomma
	cmp al, '='
	je @B
	extcallcall getword
	extcallcall skipcomm0

	cmp dx, 256
	ja .invalid
	test dx, dx
	jz .invalid

reloc	mov word [heads], dx
internaldatarelocation
	dec si
	jmp .loop

.sectors:
reloc	mov dx, msg.sectors
internaldatarelocation
	extcallcall isstring?
	jne .unit
@@:
	extcallcall skipcomma
	cmp al, '='
	je @B
	extcallcall getbyte
	extcallcall skipcomm0

	mov dh, 0
	cmp dx, 63
	ja .invalid
	test dx, dx
	jz .invalid

reloc	mov word [heads], dx
internaldatarelocation
	dec si
	jmp .loop

.unit:
	mov cl, 80h
reloc	mov dx, msg.unit
internaldatarelocation
	extcallcall isstring?
	jne @FF
@@:
	extcallcall skipcomma
	cmp al, '='
	je @B
	extcallcall getbyte
	extcallcall skipcomm0
	mov cl, dl
	dec si
@@:
	lodsb
	extcallcall getdword
	extcallcall chkeol

	push bx
	push dx

	xor ax, ax
reloc	cmp word [heads], ax
internaldatarelocation
	je @F
reloc	cmp word [sectors], ax
internaldatarelocation
	jne .no_query

@@:
	mov ah, 08h
	mov dl, cl
	stc
	int 13h
	push ss
	pop es
	jc .invalid_pop_2
	and cx, 3Fh
	jz .invalid_pop_2
reloc	mov word [sectors], cx
internaldatarelocation
	mov cl, dh
	inc cx
reloc	mov word [heads], cx
internaldatarelocation

.no_query:
	pop bp
	pop si			; si:bp = tuple
				; (sil67:sih = C, bph = H, sil05 = S)

reloc	mov di, relocateddata
linkdatarelocation line_out

	mov ax, "CH"
	stosw
	mov ax, "S "
	stosw

	mov ax, si		; al67:ah = C
	xchg al, ah		; ah67:al = C
	mov cl, 6
	shr ah, cl		; ax = C

	extcallcall hexword
	mov byte [di], ':'
	inc di

reloc	mul word [heads]
internaldatarelocation
	mov cx, bp		; ch = H
	xchg cl, ch
	mov ch, 0		; cx = H
	xchg ax, cx		; ax = H

	extcallcall hexbyte
	mov byte [di], ':'
	inc di

	add ax, cx
	adc dx, 0

	xchg ax, bx		; bx = low word
	xchg ax, dx		; ax = high word
reloc	mul word [sectors]	; dx:ax = ax = high word result
internaldatarelocation
	xchg ax, bx		; ax = low word, bx = high word result
reloc	mul word [sectors]	; dx:ax = low word result plus overflow
internaldatarelocation
	add dx, bx		; dx:ax = result

	mov cx, si		; cl05 = S
	and cx, 3Fh		; cx = S
	dec cx			; 1-based
	js .invalid

	xchg ax, cx		; ax = S

	extcallcall hexbyte
	mov word [di], " ="
	mov word [di + 2], " L"
	mov word [di + 4], "BA"
	mov byte [di + 6], " "
	add di, 7

	add ax, cx
	adc dx, 0

	xchg ax, dx
	extcallcall hexword
	mov byte [di], '_'
	inc di
	xchg dx, ax
	extcallcall hexword

	mov word [di], " ="
	scasw			; di += 2
	mov cx, 512
	mov bx, 10
	extcallcall disp_dxax_times_cx_width_bx_size.store
reloc	xor byte [relocateddata + 1], 10h
linkdatarelocation options, -3
	extcallcall disp_dxax_times_cx_width_bx_size.store
reloc	xor byte [relocateddata + 1], 10h
linkdatarelocation options, -3

	extcallcall putsline_crlf
	retn


.invalid_pop_2:
	pop ax
	pop ax
.invalid:
reloc	mov dx, msg.invalid
internaldatarelocation
	extcallcall putsz
	mov ax, 0E65h
	extcallcall setrc
	retn


	eldcall_dump_callcall ELDCALL_CALLCALL_LIST

endinstalled equ ($ + CODEFIXUP + 15) & ~15


start:
	mov bx, es
	 push ss
	 pop es
	call skipcomma
	dec si
reloc	mov dx, relocateddata
linkdatarelocation msg.install
	call isstring?
	je install
reloc	mov dx, msg.keyword_help
internaldatarelocation
	call isstring?
	je help
	call run
@@:
	call uninstall_oneshot
	xor ax, ax
	retf

help:
	lodsb
	call chkeol
reloc	mov dx, msg.help
internaldatarelocation
	call putsz
	jmp @B


uninstall_oneshot:
reloc	testopt [ss:relocateddata], 1
linkdatarelocation options7, -3
	jnz @F

reloc	mov ax, word [cs:code + eldiEndCode]
internalcoderelocation
reloc	sub ax, word [cs:code + eldiStartCode]
internalcoderelocation
reloc	sub word [relocateddata], ax
linkdatarelocation extseg_used

reloc	mov ax, word [cs:code + eldiEndData]
internalcoderelocation
reloc	sub ax, word [cs:code + eldiStartData]
internalcoderelocation
reloc	sub word [relocateddata], ax
linkdatarelocation extdata_used
@@:
	retn


DATAOFFSET equ CODEOFFSET + code_size
	addsection DATA, follows=CODE vstart=_ELD_DATA_VSTART
%define DATAFIXUP - datastart + 0
datastart:

	align 2, db 0
nountable:

msg:
.unit:			asciz "UNIT"
.heads:			asciz "HEADS"
.sectors:		asciz "SECTORS"
.invalid:		asciz "Invalid geometry!",13,10
.chstool:		asciz "CHSTOOL"
.uninstall_done:	db "CHSTOOL uninstalled."
%if _ELD_RECLAIM_HINT
			db " (Don't forget to use reclaim.eld)"
%endif
			asciz 13,10
.uninstall_error:	asciz "CHSTOOL unable to uninstall!",13,10

uinit_data: equ $
.installed:		asciz "CHSTOOL installed.",13,10
.keyword_help:		asciz "HELP"
.help:		db "This ELD can be installed residently or used transiently.",13,10
		db 13,10
		asciz

	align 16, db 0
init_data_end:
data_size equ $ - datastart
transient_data_size equ data_size

	absolute uinit_data

	alignb 4
heads:		resw 1
sectors:	resw 1

	alignb 16
uinit_data_end:
resident_data_end:
resident_data_size equ resident_data_end - datastart

%if uinit_data_end >= init_data_end
 total_data_size equ $ - datastart
%else
 total_data_size equ init_data_end - datastart
%endif
%assign _DATA_SIZE total_data_size


	usesection CODE

install:
	lodsb
	extcall chkeol

	houdini
	mov es, bx		; => ext seg (writable)

	mov ax, endresident - endinstalled
reloc	sub word [es:code + eldiEndCode], ax
internalcoderelocation		; adjust size
reloc	sub word [relocateddata], ax
linkdatarelocation extseg_used	; adjust size

%if (transient_data_size - resident_data_size) > 0
	mov ax, transient_data_size - resident_data_size
reloc	sub word [es:code + eldiEndData], ax
internalcoderelocation		; adjust size
reloc	sub word [relocateddata], ax
linkdatarelocation extdata_used	; adjust size
%endif

reloc	mov bx, word [relocateddata]
linkdatarelocation ext_command_handler
				; -> prior
reloc	mov di, command		; -> our handler
internalcoderelocation
	test bx, bx		; installing as first ?
	jz .only_first		; yes, simple --> (leave as extcall cmd3_not_ext)
	scasw			; skip entrypoint jmp strict short
	mov al, 0E9h		; = jmp near opcode
	stosb			; store
	xchg ax, bx		; ax -> next handler
	sub ax, di
	dec ax
	dec ax			; ax = ax - (di + 2)
	stosw			; store our downlink as rel16 displacement

.only_first:
reloc	setopt [es:code + eldiFlags], eldifResident
internalcoderelocation -3	; mark block as resident
reloc2	mov word [relocateddata], command
linkdatarelocation ext_command_handler, -4
internalcoderelocation		; -> our entrypoint

reloc	testopt [relocateddata], 4
linkdatarelocation options7, -3
	jnz @F
reloc	mov dx, msg.installed
internaldatarelocation
	call putsz
@@:
	xor ax, ax
	retf


%include "eldlink.asm"

	align 16
code_size equ $ - code
